{
    "$graph": [
        {
            "doc": "create textures and pack them to be a stellaris mod",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/gridsize"
                },
                {
                    "type": "Directory",
                    "id": "#main/localisation"
                },
                {
                    "type": "string",
                    "id": "#main/mod_name"
                },
                {
                    "type": "File",
                    "id": "#main/montage_font"
                },
                {
                    "type": "Directory",
                    "id": "#main/outlines"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#main/outlines",
                            "id": "#main/extractListing/folder"
                        }
                    ],
                    "out": [
                        "#main/extractListing/outlines"
                    ],
                    "run": {
                        "class": "ExpressionTool",
                        "inputs": [
                            {
                                "type": "Directory",
                                "id": "#main/extractListing/ca5c3cf7-0cde-4cd3-9590-b6483a04fb15/folder"
                            }
                        ],
                        "outputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "id": "#main/extractListing/ca5c3cf7-0cde-4cd3-9590-b6483a04fb15/outlines"
                            }
                        ],
                        "expression": "$({ 'outlines': inputs.folder.listing })\n",
                        "id": "#main/extractListing/ca5c3cf7-0cde-4cd3-9590-b6483a04fb15"
                    },
                    "id": "#main/extractListing"
                },
                {
                    "run": "#gradients_gen.cwl",
                    "in": [],
                    "out": [
                        "#main/gradients/fill_gradient",
                        "#main/gradients/highlight_gradient"
                    ],
                    "id": "#main/gradients"
                },
                {
                    "run": "#montage.cwl",
                    "in": [
                        {
                            "source": "#main/montage_font",
                            "id": "#main/montage_default/font"
                        },
                        {
                            "default": "16",
                            "id": "#main/montage_default/fontsize"
                        },
                        {
                            "source": "#main/gridsize",
                            "id": "#main/montage_default/gridsize"
                        },
                        {
                            "default": "128x128+1+1",
                            "id": "#main/montage_default/imagegeometry"
                        },
                        {
                            "source": "#main/textures/texture_default",
                            "id": "#main/montage_default/images"
                        },
                        {
                            "default": "%t",
                            "id": "#main/montage_default/label"
                        },
                        {
                            "default": "montage_default.png",
                            "id": "#main/montage_default/montagename"
                        }
                    ],
                    "out": [
                        "#main/montage_default/montage"
                    ],
                    "id": "#main/montage_default"
                },
                {
                    "run": "#montage.cwl",
                    "in": [
                        {
                            "source": "#main/montage_font",
                            "id": "#main/montage_map/font"
                        },
                        {
                            "default": "0",
                            "id": "#main/montage_map/fontsize"
                        },
                        {
                            "source": "#main/gridsize",
                            "id": "#main/montage_map/gridsize"
                        },
                        {
                            "default": "256x256+1+1",
                            "id": "#main/montage_map/imagegeometry"
                        },
                        {
                            "source": "#main/textures/texture_map",
                            "id": "#main/montage_map/images"
                        },
                        {
                            "default": "montage_map.png",
                            "id": "#main/montage_map/montagename"
                        }
                    ],
                    "out": [
                        "#main/montage_map/montage"
                    ],
                    "id": "#main/montage_map"
                },
                {
                    "run": "#montage.cwl",
                    "in": [
                        {
                            "source": "#main/montage_font",
                            "id": "#main/montage_small/font"
                        },
                        {
                            "default": "0",
                            "id": "#main/montage_small/fontsize"
                        },
                        {
                            "source": "#main/gridsize",
                            "id": "#main/montage_small/gridsize"
                        },
                        {
                            "default": "24x24+1+1",
                            "id": "#main/montage_small/imagegeometry"
                        },
                        {
                            "source": "#main/textures/texture_small",
                            "id": "#main/montage_small/images"
                        },
                        {
                            "default": "montage_small.png",
                            "id": "#main/montage_small/montagename"
                        }
                    ],
                    "out": [
                        "#main/montage_small/montage"
                    ],
                    "id": "#main/montage_small"
                },
                {
                    "in": [
                        {
                            "source": "#main/textures/texture_default",
                            "id": "#main/organize/default"
                        },
                        {
                            "source": "#main/localisation",
                            "id": "#main/organize/localisation"
                        },
                        {
                            "source": "#main/textures/texture_map",
                            "id": "#main/organize/map"
                        },
                        {
                            "source": "#main/mod_name",
                            "id": "#main/organize/mod_name"
                        },
                        {
                            "source": "#main/montage_default/montage",
                            "id": "#main/organize/montage_default"
                        },
                        {
                            "source": "#main/montage_map/montage",
                            "id": "#main/organize/montage_map"
                        },
                        {
                            "source": "#main/montage_small/montage",
                            "id": "#main/organize/montage_small"
                        },
                        {
                            "source": "#main/textures/texture_small",
                            "id": "#main/organize/small"
                        }
                    ],
                    "out": [
                        "#main/organize/folders"
                    ],
                    "run": {
                        "class": "ExpressionTool",
                        "id": "#main/organize/organize",
                        "inputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "id": "#main/organize/organize/default"
                            },
                            {
                                "type": "Directory",
                                "id": "#main/organize/organize/localisation"
                            },
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "id": "#main/organize/organize/map"
                            },
                            {
                                "type": "string",
                                "id": "#main/organize/organize/mod_name"
                            },
                            {
                                "type": "File",
                                "id": "#main/organize/organize/montage_default"
                            },
                            {
                                "type": "File",
                                "id": "#main/organize/organize/montage_map"
                            },
                            {
                                "type": "File",
                                "id": "#main/organize/organize/montage_small"
                            },
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "id": "#main/organize/organize/small"
                            }
                        ],
                        "outputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "Directory"
                                },
                                "id": "#main/organize/organize/folders"
                            }
                        ],
                        "expression": "${\n  var folders = [];\n  inputs.localisation.listing.forEach(function(f) { f.basename = inputs.mod_name + '_l_' + f.basename });\n  folders.push({\n    'class': 'Directory',\n    'basename': 'out/' + inputs.mod_name + '/flags/' + inputs.mod_name,\n    'listing': inputs.default\n  });\n  folders.push({\n    'class': 'Directory',\n    'basename': 'out/' + inputs.mod_name + '/flags/' + inputs.mod_name + '/map',\n    'listing': inputs.map\n  });\n  folders.push({\n    'class': 'Directory',\n    'basename': 'out/' + inputs.mod_name + '/flags/' + inputs.mod_name + '/small',\n    'listing': inputs.small\n  });\n  folders.push({\n    'class': 'Directory',\n    'basename': 'out/workshop',\n    'listing': [inputs.montage_default, inputs.montage_map, inputs.montage_small]\n  });\n  folders.push({\n    'class': 'Directory',\n    'basename': 'out/' + inputs.mod_name + '/localisation/',\n    'listing': inputs.localisation.listing\n  });\n  return { 'folders': folders };\n}\n"
                    },
                    "id": "#main/organize"
                },
                {
                    "run": "#emblem_textures.cwl",
                    "scatter": "#main/textures/outline",
                    "in": [
                        {
                            "source": "#main/gradients/fill_gradient",
                            "id": "#main/textures/fill_gradient"
                        },
                        {
                            "source": "#main/gradients/highlight_gradient",
                            "id": "#main/textures/highlight_gradient"
                        },
                        {
                            "source": "#main/extractListing/outlines",
                            "id": "#main/textures/outline"
                        }
                    ],
                    "out": [
                        "#main/textures/texture_default",
                        "#main/textures/texture_map",
                        "#main/textures/texture_small"
                    ],
                    "id": "#main/textures"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "outputSource": "#main/organize/folders",
                    "id": "#main/texture_map"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#emblem_textures.cwl/fill_gradient"
                },
                {
                    "type": "File",
                    "id": "#emblem_textures.cwl/highlight_gradient"
                },
                {
                    "type": "File",
                    "id": "#emblem_textures.cwl/outline"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#emblem_textures.cwl/default/texture",
                    "id": "#emblem_textures.cwl/texture_default"
                },
                {
                    "type": "File",
                    "outputSource": "#emblem_textures.cwl/map/texture",
                    "id": "#emblem_textures.cwl/texture_map"
                },
                {
                    "type": "File",
                    "outputSource": "#emblem_textures.cwl/small/texture",
                    "id": "#emblem_textures.cwl/texture_small"
                }
            ],
            "steps": [
                {
                    "run": "#border_emblem.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/border/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/border/border_emblem"
                    ],
                    "id": "#emblem_textures.cwl/border"
                },
                {
                    "run": "#texture_default.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "valueFrom": "$(self.nameroot)",
                            "id": "#emblem_textures.cwl/default/file_name"
                        },
                        {
                            "source": "#emblem_textures.cwl/highlight/highlight_emblem",
                            "id": "#emblem_textures.cwl/default/highlight"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/default/texture"
                    ],
                    "id": "#emblem_textures.cwl/default"
                },
                {
                    "run": "#gradient_emblem.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/fill_gradient",
                            "id": "#emblem_textures.cwl/gradient/fill_gradient"
                        },
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/gradient/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/gradient/gradient_emblem"
                    ],
                    "id": "#emblem_textures.cwl/gradient"
                },
                {
                    "run": "#highlight_emblem.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/gradient/gradient_emblem",
                            "id": "#emblem_textures.cwl/highlight/gradient_emblem"
                        },
                        {
                            "source": "#emblem_textures.cwl/highlight_mask/highlight_mask",
                            "id": "#emblem_textures.cwl/highlight/gradient_mask"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/highlight/highlight_emblem"
                    ],
                    "id": "#emblem_textures.cwl/highlight"
                },
                {
                    "run": "#highlight_mask.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/highlight_gradient",
                            "id": "#emblem_textures.cwl/highlight_mask/gradient_mask"
                        },
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/highlight_mask/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/highlight_mask/highlight_mask"
                    ],
                    "id": "#emblem_textures.cwl/highlight_mask"
                },
                {
                    "run": "#texture_map.cwl",
                    "in": [
                        {
                            "valueFrom": "$(inputs.outline.nameroot)",
                            "id": "#emblem_textures.cwl/map/file_name"
                        },
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "id": "#emblem_textures.cwl/map/outline"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/map/texture"
                    ],
                    "id": "#emblem_textures.cwl/map"
                },
                {
                    "run": "#texture_small.cwl",
                    "in": [
                        {
                            "source": "#emblem_textures.cwl/border/border_emblem",
                            "id": "#emblem_textures.cwl/small/border"
                        },
                        {
                            "source": "#emblem_textures.cwl/outline",
                            "valueFrom": "$(self.nameroot)",
                            "id": "#emblem_textures.cwl/small/file_name"
                        },
                        {
                            "source": "#emblem_textures.cwl/highlight/highlight_emblem",
                            "id": "#emblem_textures.cwl/small/highlight"
                        }
                    ],
                    "out": [
                        "#emblem_textures.cwl/small/texture"
                    ],
                    "id": "#emblem_textures.cwl/small"
                }
            ],
            "id": "#emblem_textures.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://gitlab.com/unduthegun/stellaris-emblem-lab/raw/cwl/textures/tools/border_emblem.sh"
                    },
                    "id": "#border_emblem.cwl/command"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#border_emblem.cwl/outline"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "border_emblem.png"
                    },
                    "id": "#border_emblem.cwl/border_emblem"
                }
            ],
            "id": "#border_emblem.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://gitlab.com/unduthegun/stellaris-emblem-lab/raw/cwl/textures/tools/gradient_emblem.sh"
                    },
                    "id": "#gradient_emblem.cwl/command"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#gradient_emblem.cwl/fill_gradient"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#gradient_emblem.cwl/outline"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "gradient_emblem.png"
                    },
                    "id": "#gradient_emblem.cwl/gradient_emblem"
                }
            ],
            "id": "#gradient_emblem.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://gitlab.com/unduthegun/stellaris-emblem-lab/raw/cwl/textures/tools/gradients_gen.sh"
                    },
                    "id": "#gradients_gen.cwl/command"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "fill_gradient.png"
                    },
                    "id": "#gradients_gen.cwl/fill_gradient"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "highlight_gradient.png"
                    },
                    "id": "#gradients_gen.cwl/highlight_gradient"
                }
            ],
            "id": "#gradients_gen.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://gitlab.com/unduthegun/stellaris-emblem-lab/raw/cwl/textures/tools/highlight_emblem.sh"
                    },
                    "id": "#highlight_emblem.cwl/command"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#highlight_emblem.cwl/gradient_emblem"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#highlight_emblem.cwl/gradient_mask"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "highlight_emblem.png"
                    },
                    "id": "#highlight_emblem.cwl/highlight_emblem"
                }
            ],
            "id": "#highlight_emblem.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://gitlab.com/unduthegun/stellaris-emblem-lab/raw/cwl/textures/tools/highlight_mask.sh"
                    },
                    "id": "#highlight_mask.cwl/command"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#highlight_mask.cwl/gradient_mask"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#highlight_mask.cwl/outline"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "highlight_mask.png"
                    },
                    "id": "#highlight_mask.cwl/highlight_mask"
                }
            ],
            "id": "#highlight_mask.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://gitlab.com/unduthegun/stellaris-emblem-lab/raw/cwl/textures/tools/texture_default.sh"
                    },
                    "id": "#texture_default.cwl/command"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#texture_default.cwl/file_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#texture_default.cwl/highlight"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.file_name).dds"
                    },
                    "id": "#texture_default.cwl/texture"
                }
            ],
            "id": "#texture_default.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://gitlab.com/unduthegun/stellaris-emblem-lab/raw/cwl/textures/tools/texture_map.sh"
                    },
                    "id": "#texture_map.cwl/command"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#texture_map.cwl/file_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#texture_map.cwl/outline"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.file_name).dds"
                    },
                    "id": "#texture_map.cwl/texture"
                }
            ],
            "id": "#texture_map.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sh",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#texture_small.cwl/border"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "default": {
                        "class": "File",
                        "location": "https://gitlab.com/unduthegun/stellaris-emblem-lab/raw/cwl/textures/tools/texture_small.sh"
                    },
                    "id": "#texture_small.cwl/command"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#texture_small.cwl/file_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#texture_small.cwl/highlight"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.file_name).dds"
                    },
                    "id": "#texture_small.cwl/texture"
                }
            ],
            "id": "#texture_small.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "montage",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "undu/imagemagick"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "black",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-background"
                    },
                    "id": "#montage.cwl/backgroundcolour"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-font"
                    },
                    "id": "#montage.cwl/font"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 7,
                        "prefix": "-pointsize"
                    },
                    "id": "#montage.cwl/fontsize"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-tile"
                    },
                    "id": "#montage.cwl/gridsize"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-geometry"
                    },
                    "id": "#montage.cwl/imagegeometry"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 8
                    },
                    "id": "#montage.cwl/images"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-label"
                    },
                    "id": "#montage.cwl/label"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 9
                    },
                    "id": "#montage.cwl/montagename"
                },
                {
                    "type": "string",
                    "default": "white",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-fill"
                    },
                    "id": "#montage.cwl/textcolour"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.montagename)"
                    },
                    "id": "#montage.cwl/montage"
                }
            ],
            "id": "#montage.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
